class TagGraph {

  HashMap nodeMap = new HashMap();
  ArrayList springs = new ArrayList();

  boolean showText = true;
  boolean showRolloverText = true;
  boolean showRolloverNeighbours = false;

  PFont font;
  float textsize;

  float minX = 0;
  float minY = 0;
  float maxX = width;
  float maxY = height;


  float springLengthMin = 50;
  float springLengthMax = 100;
  float springStiffness = 0.6;
  float springDamping = 0.4;

  float saveSLength=0;
  float saveFNZFactor=0;
  float saveTNZFactor=0;
  float saveRadius = 0;
  float saveY = 0;


  boolean coordsSet = false;

  TagGraph()
  {
    font = createFont("Miso", 12);
  }


  void getAllTags() {
    int numSites = xml.getChildCount();
    int ii = 0;
    int numWidth = width/numSites;
    for (int i = 0; i < numSites; i++) {
      XMLElement kid = xml.getChild(i);
      int numObj = kid.getChildCount();
      //println(numObj);
      String tagId = kid.getName();
      TagNode newTagNode = new TagNode(this, i*numWidth+random(-50, 50)+numWidth/2, height/2+random(-300, 300), zLevel);


      newTagNode.setID(tagId);
      newTagNode.setMaxX(newTagNode.x+50);
      newTagNode.setMinX(newTagNode.x-50);
      newTagNode.setMaxY(newTagNode.y+50);
      newTagNode.setMinY(newTagNode.y-50);
      newTagNode.setMinZ(newTagNode.z);
      newTagNode.setMaxZ(newTagNode.z);
      newTagNode.setDamping(0.6);
      newTagNode.setStrength(-115);
      newTagNode.setRadius(30);
      newTagNode.setBoundary(100, 100, width-100, height-100);
      nodeMap.put(tagId, newTagNode);
      for (int j= 0; j < numObj; j++)
      {
        XMLElement obj = kid.getChild(j);
        String id = obj.getString("id"); 
        String img = obj.getString("img"); 
        String img2 = null;
        //println(obj.getString("img2"));
        if (obj.getString("img2") != null) {

          img2 = obj.getString("img2");
        }

        String desc = obj.getString("description");
        //println(id + " : " + url + " : " + site);

        TagNode newNode = new TagNode(this, i*numWidth+numWidth/2+random(-50, 50), height/2+random(-200, 200), zLevel);
        newNode.setID(id);
        //newNode.zDepth(ii);
        newNode.setPicture(img);
        if (obj.getString("img2") != null) {
          newNode.setContent(img2);
        }
        else {

          newNode.setContent(img);
        }
        newNode.setBoundary(100, 100, width-100, height-100);
        newNode.setRadius(200);
        //newNode.setDiameter(100);
        newNode.setStrength(-75);
        newNode.setDamping(0.9);
        nodeMap.put(id, newNode);
        ii+=1;
        Spring addedSpring = addSpring(newTagNode.id, newNode.id);
      }
    }
  }

  Spring addSpring(String fromID, String toID) {
    TagNode fromNode, toNode; 
    fromNode = (TagNode) nodeMap.get(fromID);
    toNode = (TagNode) nodeMap.get(toID);

    // if one of the nodes do not exist, stop creating spring
    if (fromNode==null) return null;
    if (toNode==null) return null;

    if (getSpring(fromNode, toNode) == null) {
      // create a new spring
      Spring newSpring = new Spring(fromNode, toNode, springLengthMin, springStiffness, 0.9);
      springs.add(newSpring);
      return newSpring;
    }

    return null;
  }

  Spring getSpring(Node theFromNode, Node theToNode) {
    for (int i = 0; i < springs.size(); i++) {
      Spring s = (Spring) springs.get(i);
      if (s.fromNode == theFromNode && s.toNode == theToNode) {
        return s;
      }
    }
    return null;
  }

  void update(int mX, int mY) {
    // use this function also to get actual width and heigth of the graph
    minX = Float.MAX_VALUE; 
    minY = Float.MAX_VALUE;
    maxX = -Float.MAX_VALUE; 
    maxY = -Float.MAX_VALUE;

    // make an Array out of the values in nodeMap
    TagNode[] nodes = (TagNode[]) nodeMap.values().toArray(new TagNode[0]);

    for (int i = 0; i < nodes.length; i++) {
      nodes[i].attract(nodes);


      nodes[i].radius = picSize*nodes[i].getZoomFactor();
    }
    for (int i = 0; i < springs.size(); i++) {
      float distance;
      float tempDistance;
      if (kinectFront) {
        tempDistance = maxZDistance;
        distance = maxZDistance;
      }
      else {
        tempDistance = minZDistance;
        distance = minZDistance;
      }
      Spring s = (Spring) springs.get(i);
      if (s == null) break;
      Node tNode = s.getToNode(); // image-Node
      String tNodeID = tNode.getID(); 
      TagNode toNode =(TagNode) nodeMap.get(tNodeID);

      Node fNode = s.getFromNode(); // tag-Node
      String fNodeID = fNode.getID(); 
      TagNode fromNode =(TagNode) nodeMap.get(fNodeID);


      ArrayList nearUsers = new ArrayList();
      for ( int u = 0; u < kinectUserList.length; u ++)
      {
        float xDistance = dist(fromNode.x, 0, kinectUserList[u].x, 0);

        if (xDistance < maxDistance)
        {
          nearUsers.add(kinectUserList[u]);
        }
      }
      float nUDist;
      float tempNUDist;
      float nUZDist;
      if (kinectFront)

      {
        nUDist = maxZDistance;
        tempNUDist = maxZDistance;
        nUZDist = maxZDistance;
      }
      else {

        nUDist = minZDistance;
        tempNUDist = minZDistance;
        nUZDist = minZDistance;
      }
      for (int nu = 0; nu < nearUsers.size(); nu++)
      {

        //println("near Users: bereich: "+  fromNode.getID()+ ", anzahl Users: " + nearUsers.size());
        PVector nearUser = (PVector) nearUsers.get(nu);
        nUDist = dist(fromNode.x, fromNode.z, nearUser.x, nearUser.z);
        //println("nearUser =" + nearUser.z);
        if (nUDist < tempNUDist && kinectFront)

        {
          tempNUDist = nUDist;
          nUZDist = nearUser.z;
        }

        if (nUDist > tempNUDist && !kinectFront)

        {
          tempNUDist = nUDist;
          nUZDist = nearUser.z;
        } 

        distance = nUZDist;

        // kinect hinten
      }
      if (!kinectFront) {
        distance = map(distance, minZDistance, maxZDistance, maxZDistance, minZDistance);
      }
      //println(distance);

      if (distance < minZDistance)
      {
        distance = minZDistance;
      }

      if (distance > maxZDistance)
      {
        distance = maxZDistance;
      }

      //println(distance);

      // println("distance =" + distance);
      //distance = maxZDistance;
      if (distance < maxZDistance)
      {
        if (!fromNode.isFading()) {
          float tempTime = fromNode.fading();
          if (tempTime < fadeTime)
          {
            s.setLength(map(tempTime, 0, fadeTime, springLengthMin, map(distance, minZDistance, maxZDistance, springLengthMax, springLengthMin)));
            toNode.setZoomFactor(map(tempTime, 0, fadeTime, minZoom, map(distance, minZDistance, maxZDistance, maxZoom, minZoom)));
            fromNode.setZoomFactor(map(tempTime, 0, fadeTime, minZoom, map(distance, minZDistance, maxZDistance, maxZoom, minZoom)));
            toNode.setRadius(map(tempTime, 0.0, fadeTime, picSize*2, map(distance, minZDistance, maxZDistance, picSize+80, picSize*2)));
            fromNode.setRadius(50);
            fromNode.y = map(tempTime, 0.0, fadeTime, height/2, map(distance, minZDistance, maxZDistance, height-100, height/2));
          }
          else {
            fromNode.changeFading();
          }
        }
        else {


          s.setLength(map(distance, minZDistance, maxZDistance, springLengthMax, springLengthMin));
          toNode.setZoomFactor(map(distance, minZDistance, maxZDistance, maxZoom, minZoom));
          fromNode.setZoomFactor(map(distance, minZDistance, maxZDistance, maxZoom, minZoom));
          toNode.setRadius(map(distance, minZDistance, maxZDistance, picSize+80, picSize*2));
          fromNode.setRadius(50);
        }
        if (!fromNode.coordsSet())
        {
          fromNode.setCoords(fromNode.x, fromNode.y);
          fromNode.changeCoordsSet();
        }

        fromNode.x = fromNode.xCoordinate();
        fromNode.y = fromNode.yCoordinate();
        fromNode.y = map(distance, minZDistance, maxZDistance, height-400, height/2);
      }
      else if (fromNode.coordsSet)
      {
        fromNode.changeCoordsSet();
      }

      else if (fromNode.isFading())
      {
        if (fromNode.fadeFirst)
        {
          saveSLength= s.getLength();
          saveFNZFactor= fromNode.pictureZoom;
          saveTNZFactor=toNode.pictureZoom;
          saveRadius = toNode.getRadius();
          saveY = fromNode.y;
        }


        float tempTime = fromNode.fading();
        //println(tempTime);
        if (tempTime < fadeTime)
        {
          s.setLength(map(tempTime, 0, fadeTime, saveSLength, springLengthMin));
          toNode.setZoomFactor(map(tempTime, 0, fadeTime, saveFNZFactor, minZoom));
          fromNode.setZoomFactor(map(tempTime, 0, fadeTime, saveTNZFactor, minZoom));
          toNode.setRadius(map(tempTime, 0.0, fadeTime, saveRadius, picSize*2));
          fromNode.setRadius(50);
          fromNode.y = map(tempTime, 0.0, fadeTime, saveY, height/2);
        }
        else {
          fromNode.changeFading();
        }
      }


      canvas.beginDraw();
      canvas.smooth();
      canvas.stroke(1);

      //canvas.line(fromNode.x, fromNode.y, toNode.x, toNode.y);
      canvas.endDraw();
      s.update();
    }

    for (int i = 0; i < nodes.length; i++) {
      nodes[i].update();
      minX = min(nodes[i].x, minX);
      maxX = max(nodes[i].x, maxX);
      minY = min(nodes[i].y, minY);
      maxY = max(nodes[i].y, maxY);
      //nodes[i].updateSize(dist(mX,nodes[i].x,mY,nodes[i].y));
    }
  }


  void draw() {
    //println(nodeMap.size()); 
    Iterator iter = nodeMap.entrySet().iterator();
    while (iter.hasNext ()) {
      Map.Entry me = (Map.Entry) iter.next();
      TagNode node = (TagNode) me.getValue();
      node.draw();
    }
    iter = nodeMap.entrySet().iterator();
    while (iter.hasNext ()) {
      Map.Entry me = (Map.Entry) iter.next();
      TagNode node = (TagNode) me.getValue();
      //node.drawLabel();
    }
  }
}

