import generativedesign.*;
import processing.opengl.*;
import codeanticode.glgraphics.*;
import SimpleOpenNI.*;
import geomerative.*;


float maxDistance = 200.0;

float minZDistance = 500.0;
float maxZDistance = 3000.0;

boolean kinectFront = false;

int picSize = 100;
int zLevel = -500;

float maxZoom=1;
float minZoom=0.5;

int maxUserBalls = 50;
int userResolution = 15;


GLGraphicsOffScreen canvas;
GLGraphicsOffScreen canvas3;
XMLElement xml;
TagGraph myTagGraph;
PApplet root = this;
PApplet thisPApplet = this;


SimpleOpenNI kinect;
PFont font;
PVector kinectUserList[];
int fadeTime = 1000;
int[] sceneMap;

// ball Zeugs
char typedKey = 'a';
float spacing = 20;
float spaceWidth = 150; // width of letter ' '
int bFontSize = 250;
float lineSpacing = bFontSize;
float stepSize = 200;
float danceFactor = .5;
float letterX = 0;
float textW = 0;
float letterY = lineSpacing;


RFont bFont;
ArrayList grpListe = new ArrayList();
RGroup[] grp;
RPoint[] pnts;
HashMap uBalls = new HashMap();

boolean freeze = false;
//  ** FONT

Ball[] myBall;
int ballAmount = 450;
int bDistance = 200;
float lineWeight=.1;
float lineWeight2=.3;
int radius = 0;

//endBall
IntVector uList;

void setup() {
   //size(1680, 1050, GLConstants.GLGRAPHICS);
  size(2560, 1024, GLConstants.GLGRAPHICS);
  kinect = new SimpleOpenNI(this, SimpleOpenNI.RUN_MODE_MULTI_THREADED);
  kinect.enableDepth();
  kinect.enableScene();
  kinect.enableUser(SimpleOpenNI.SKEL_PROFILE_NONE);
  font = loadFont("FrutigerLTCom-Condensed-48.vlw"); 

  if (kinectFront) {
    kinect.setMirror(true);
  }

  textFont(font, 12);
  uList = new IntVector();


  xml = new XMLElement(this, "data.xml"); 
  //background(255);
  smooth();
  noStroke();
  canvas = new GLGraphicsOffScreen(this, width, height, true);
  canvas.clear(255);
  canvas.smooth();
  canvas3 = new GLGraphicsOffScreen(this, width, height, true);
  canvas3.clear(255);
  canvas3.smooth();
  myTagGraph = new TagGraph();
  myTagGraph.getAllTags();
  float fov = PI/3.0;
  float cameraZ = (height/2.0) / tan(fov/2.0);
  perspective(fov, float(width)/float(height), cameraZ/10.0, cameraZ*10.0);

  //BALL
  RG.init(this);
  bFont = new RFont("FreeSansNoPunch.ttf", bFontSize, RFont.LEFT);
  RCommand.setSegmentLength(25);
  RCommand.setSegmentator(RCommand.UNIFORMLENGTH);
  grpListe.add("_");
  grpListe.add("100 Jahre schweizer Grafik");
  grpListe.add("_");
  grpListe.add("Ausstellung SQ310");
  grpListe.add("_");
  int m = 0;
  grp = new RGroup[grpListe.size()];

  for (int l=0; l < grpListe.size();l++) {

    grp[m]= bFont.toGroup(grpListe.get(l)+" ");
    m++;
  }

  makeBalls(ballAmount);

  myBall = new Ball[ballAmount];
  for (int i = 0; i < ballAmount; i++) {

    if (i < ballAmount/3)
    {

      myBall[i] = new Ball(random(-5, 5));
    } 
    else
    {
      myBall[i] = new Ball(random(-.01, .01));
    }
  }
  noCursor();
}


void draw() {
  background(230);
  canvas.beginDraw();
  canvas.clear(230, 0);
  kinect.update();
  sceneMap = kinect.sceneMap();
  uList = new IntVector();
  kinect.getUsers(uList);
  kinectUserList = new PVector[int(uList.size())];
  kinectUserList = kinectUserList(uList);

  float numWidth = width/5;

  canvas.endDraw();

  myTagGraph.update(mouseX, mouseY);
  myTagGraph.draw();

  drawFontBall();
  drawBalls();
  drawUPoints();
  image(canvas.getTexture(), 0, 0);
  //fill(255);
 // text(frameRate, 20, 20);
}

